package jex;

import com.sun.star.bridge.XUnoUrlResolver;
import com.sun.star.lang.XMultiServiceFactory;
import com.sun.star.lang.XServiceInfo;
import com.sun.star.lang.XComponent;
import com.sun.star.lang.XMultiComponentFactory;
import com.sun.star.uno.XComponentContext;
import com.sun.star.uno.UnoRuntime;
import com.sun.star.uno.XInterface;
import com.sun.star.frame.XComponentLoader;
import com.sun.star.beans.PropertyValue;
import com.sun.star.beans.Property;
import com.sun.star.beans.XPropertySetInfo;
import com.sun.star.frame.XDesktop;
import com.sun.star.frame.XFrame;
import com.sun.star.frame.XController;
import com.sun.star.frame.XModel;
import com.sun.star.frame.XDispatchHelper;
import com.sun.star.frame.XDispatchProvider;
import com.sun.star.view.XSelectionSupplier;
import com.sun.star.view.XLineCursor;
import com.sun.star.container.XIndexAccess;
import com.sun.star.container.XNameAccess;
import com.sun.star.container.XEnumerationAccess;
import com.sun.star.text.XText;
import com.sun.star.text.XTextRange;
import com.sun.star.text.XTextFrame;
import com.sun.star.text.XTextContent;
import com.sun.star.text.XTextViewCursorSupplier;
import com.sun.star.text.XTextViewCursor;
import com.sun.star.text.XTextCursor;
import com.sun.star.text.TextContentAnchorType;
import com.sun.star.text.VertOrientation;
import com.sun.star.text.XTextEmbeddedObject;
import com.sun.star.text.XTextDocument;
import com.sun.star.text.ControlCharacter;
import com.sun.star.text.XTextGraphicObjectsSupplier;
import com.sun.star.beans.XPropertySet;
import com.sun.star.drawing.XShape;
import com.sun.star.drawing.XShapeGrouper;
import com.sun.star.drawing.XShapes;
import com.sun.star.drawing.XDrawPageSupplier;
import com.sun.star.drawing.HomogenMatrixLine3;
import com.sun.star.drawing.HomogenMatrix3;
import com.sun.star.awt.Size;
import com.sun.star.awt.FontWeight;
import com.sun.star.awt.Point;
import com.sun.star.awt.XWindow;
import com.sun.star.table.BorderLine;
import com.sun.star.util.XSearchable;
import com.sun.star.util.XSearchDescriptor;
import com.sun.star.container.XNameAccess;
import com.sun.star.container.XContentEnumerationAccess;
import com.sun.star.container.XEnumeration;
import com.sun.star.awt.FontSlant;
import com.sun.star.connection.*;

import java.awt.Color;
import java.util.*;
import java.io.*;

import jex.Jex;
import jex.Jexmath;

public class Jexoo extends MathDisplay{
     
    static String connectStr = "uno:socket,host=localhost,port=8100;urp;StarOffice.ServiceManager";
    public static XDesktop xd;
    public static XDispatchHelper xdh;

    public Jex jex;
    public String jexname = null;

    public Jexoo(Jex jex) {
	this.jex = jex;
    }

    public Jexoo(){}
    
    public static void connect(){
    
        try{    
            XComponentContext xcctxt = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
            XMultiComponentFactory xmcf = xcctxt.getServiceManager();
            Object objectUrlResolver = xmcf.createInstanceWithContext("com.sun.star.bridge.UnoUrlResolver", xcctxt);
            XUnoUrlResolver xurlr = (XUnoUrlResolver) UnoRuntime.queryInterface( XUnoUrlResolver.class, objectUrlResolver );
            Object object0 = xurlr.resolve(connectStr);
            xmcf = (XMultiComponentFactory)  UnoRuntime.queryInterface(XMultiComponentFactory.class, object0);
            XPropertySet xpsmcf = (XPropertySet) UnoRuntime.queryInterface(XPropertySet.class, xmcf);
            Object odc = xpsmcf.getPropertyValue("DefaultContext");
            xcctxt = (XComponentContext) UnoRuntime.queryInterface(XComponentContext.class, odc);
            xd = (XDesktop) UnoRuntime.queryInterface(XDesktop.class, xmcf.createInstanceWithContext("com.sun.star.frame.Desktop", xcctxt));
            xdh = (XDispatchHelper) UnoRuntime.queryInterface(XDispatchHelper.class, xmcf.createInstanceWithContext("com.sun.star.frame.DispatchHelper", xcctxt));
        }
        catch(Exception exception) {
            System.err.println("connect exception: " +  exception);
	    xd = null;
        }
    }
    
    Object objectS;
    XTextViewCursor xvc;
    XComponent xcc;
    XTextDocument xdoc;
    XMultiServiceFactory xmsf;
    XModel xm;
    XController xc2;
    XFrame xgf;
    XDispatchProvider xdp;

    
    void getCurrent(){
	if(xd == null) connect();
	try{
        	xgf = xd.getCurrentFrame();
	}
	catch(Exception e){
		System.out.println("getCurrent exception: " + e);
		xd = null;
		connect();
		if(xd == null) return;
		xgf = xd.getCurrentFrame();
	}
        XController xc = xgf.getController();
        XSelectionSupplier xss = (XSelectionSupplier) UnoRuntime.queryInterface(XSelectionSupplier.class, xc);
	if(xss == null) System.out.println("no selection");
        objectS = xss.getSelection();
        xcc = xd.getCurrentComponent();
	xdoc = (XTextDocument)UnoRuntime.queryInterface(XTextDocument.class, xcc);
        xmsf = (XMultiServiceFactory) UnoRuntime.queryInterface(XMultiServiceFactory.class, xcc);
        xm = (XModel) UnoRuntime.queryInterface(XModel.class, xcc);
        xc2 = xm.getCurrentController();
        XTextViewCursorSupplier xtvcs = (XTextViewCursorSupplier) UnoRuntime.queryInterface(XTextViewCursorSupplier.class, xc2);
        xvc = xtvcs.getViewCursor();
	xdp = (XDispatchProvider) UnoRuntime.queryInterface(XDispatchProvider.class, xc2);
    }
    
    public static void main(String args[]) {
        connect();
	ooListen ool = new ooListen();
	ool.start();
        Jex jex = Jex.initJ();
        jex.setMathDisplay(new Jexoo(jex));
    }

    public MathDisplay getNewMathDisplay(Object jex){
	return new Jexoo((Jex) jex);
    }
    
    XTextFrame xf;
    XShapes xss;
    int fsize;
    int hf = 35;
    int vf = 35;
    int base;
    PropertyValue[] cpv;

    private void setProp(int i, String name, String value){
		cpv[i] = new com.sun.star.beans.PropertyValue();
		cpv[i].Name = name;
		cpv[i].Value = value;
    }

    private void setProp(int i, String name, int value){
		cpv[i] = new com.sun.star.beans.PropertyValue();
		cpv[i].Name = name;
		cpv[i].Value = new Integer(value);
    }

    private void setProp(int i, String name, boolean value){
		cpv[i] = new com.sun.star.beans.PropertyValue();
		cpv[i].Name = name;
		cpv[i].Value = new Boolean(value);
    }

    private boolean findview(String str){
		PropertyValue pv[] = new com.sun.star.beans.PropertyValue[19];
		cpv = pv;
		setProp(0, "SearchItem.StyleFamily", 2);
		setProp(1, "SearchItem.CellType", 0);
		setProp(2, "SearchItem.RowDirection", true);
		setProp(3, "SearchItem.AllTables", false);
		setProp(4, "SearchItem.Backward", true);
		setProp(5, "SearchItem.Pattern", false);
		setProp(6, "SearchItem.Content", false);
		setProp(7, "SearchItem.AsianOptions", false);
		setProp(8, "SearchItem.AlgorithmType", 0);
		setProp(9, "SearchItem.SearchFlags", 65536);
		setProp(10, "SearchItem.SearchString", str);
		setProp(11, "SearchItem.ReplaceString", "");
		setProp(12, "SearchItem.Locale", 255);
		setProp(13, "SearchItem.ChangedChars", 2);
		setProp(14, "SearchItem.DeletedChars", 2);
		setProp(15, "SearchItem.InsertedChars", 2);
		setProp(16, "SearchItem.TransliterateFlags", 1280);
		setProp(17, "SearchItem.Command", 0);
		setProp(18, "Quiet", true);  
		Boolean b = (Boolean) xdh.executeDispatch(xdp, ".uno:ExecuteSearch", "", 0, pv);
		if(!b.booleanValue()){
			setProp(4, "SearchItem.Backward", false);
			b = (Boolean) xdh.executeDispatch(xdp, ".uno:ExecuteSearch", "", 0, pv);
			return(b.booleanValue()); 
		}		
		return true;
    }

    public void printEq(String tex, DefaultContext d){

	getCurrent();
	try{
System.out.println("hi");
FileOutputStream out = new FileOutputStream("/home/dlevine/image.wmf");
//note little endian - low byte gets written first
out.write(0x01); out.write(0x00); //FileType: is disk metafile
out.write(0x09); out.write(0x00); //HeaderSize (always 9)
out.write(0x00); out.write(0x03); //Windows Version
out.write(0x36); out.write(0x00); //
out.write(0x00); out.write(0x00); //FileSize in words
out.write(0x02); out.write(0x00); //NumOfObjects
out.write(0x0c); out.write(0x00); //
out.write(0x00); out.write(0x00); //MaxRecordSize in words
out.write(0x00); out.write(0x00); //Not used, always 0

out.write(0x08); out.write(0x00); //
out.write(0x00); out.write(0x00); //rdsize
out.write(0xfa); out.write(0x02); //rdfunction createpenindirect: this is object 0 <><>HERE
out.write(0x00); out.write(0x00); //style  
out.write(0x00); out.write(0x00); //width x
out.write(0x00); out.write(0x00); //width y
out.write(0x00); out.write(0xff); //
out.write(0x00); out.write(0x00); //green color

out.write(0x04); out.write(0x00); //
out.write(0x00); out.write(0x00); //rdsize
out.write(0x2d); out.write(0x01); //rdfunction select object
out.write(0x00); out.write(0x00); //object 0

out.write(0x07); out.write(0x00); //
out.write(0x00); out.write(0x00); //rdsize
out.write(0xfc); out.write(0x02); //rdfunction createbrushindirect: this is object 1
out.write(0x00); out.write(0x00); //style 0000 00ff 00ff 0000
out.write(0xff); out.write(0x00); //
out.write(0xff); out.write(0x00); //violet color
out.write(0x00); out.write(0x00); //hatch

out.write(0x04); out.write(0x00); //
out.write(0x00); out.write(0x00); //rdsize
out.write(0x2d); out.write(0x01); //rdfunction select object
out.write(0x01); out.write(0x00); //object 1

out.write(0x07); out.write(0x00); //
out.write(0x00); out.write(0x00); //rdsize
out.write(0xfc); out.write(0x02); //rdfunction rectangle
out.write(0x00); out.write(0x00); //y lr
out.write(0xff); out.write(0x00); //x lr
out.write(0xff); out.write(0x00); //y ul
out.write(0x00); out.write(0x00); //x ul

out.write(0x0c); out.write(0x00); //
out.write(0x00); out.write(0x00); //rdsize
out.write(0x00); out.write(0x00); //fdfunction textout
out.write(0x0c); out.write(0x00); //count
out.write(0x48); out.write(0x65); //
out.write(0x6c); out.write(0x6c); //
out.write(0x6f); out.write(0x20); //
out.write(0x50); out.write(0x65); //
out.write(0x6f); out.write(0x70); //
out.write(0x6c); out.write(0x65); //string: hellow people
out.write(0x0a); out.write(0x00); //y
out.write(0x0a); out.write(0x00); //x

out.write(0x00); out.write(0x00); //
out.write(0x03); out.write(0x00); //rdsize
out.write(0x00); out.write(0x00); //fdfunction terminating record

out.close();

		if(jexname != null){
			boolean found = false;
			XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
			if(xs != null){
				XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, objectS);
				String str = (String) xsp.getPropertyValue("LinkDisplayName");
				if(str.equals(jexname)) found = true;
			}
			XTextContent xt;
			if(!found){	
				XPropertySet xsp;	
				XTextGraphicObjectsSupplier xgos = (XTextGraphicObjectsSupplier)UnoRuntime.queryInterface(XTextGraphicObjectsSupplier.class, xcc);
				XNameAccess xna = xgos.getGraphicObjects();
				Object something = xna.getByName(jexname);		
				//String ens[] = xna.getElementNames();
				//for(int i = 0; i < ens.length; i++) {
				//	something = xna.getByName(ens[i]);
				//	xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, something);
				//	String str = (String) xsp.getPropertyValue("HyperLinkName");
				//	System.out.println(str);
				//	if(str.equals(jexname)) {
				//		found = true;
				//		break;
				//	}
				//}
				xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, something);
			}
			else xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, objectS);
      			XText xdt = xdoc.getText();
			XTextRange xtr = xt.getAnchor();
			XTextCursor xma = xdt.createTextCursorByRange(xtr);
        		xma.goLeft((short)1, false);
			xma.goRight((short)1, false);
			String tname = getName();
			xdt.insertString(xma, tname, true);
			findview(tname);
			xdh.executeDispatch(xdp, ".uno:Delete", "", 0, null);
			xvc.goRight((short) 1, true);
		}	
		insertEq(tex, d);
	}
	catch(Exception exception){System.err.println("printEq: " + exception);}
    }

    private void insertEq(String tex, DefaultContext d){
        try{
		BoxMetrics m = jex.jexPane.writeGraphicFile("/home/dlevine/image.png", 16);
		
		getCurrent();
		XTextContent xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, objectS);
		if(xt != null) xdh.executeDispatch(xdp, ".uno:Delete", "", 0, null);

		//getCurrent();
            	XText xdt = xvc.getText();
           	XTextCursor xma = xdt.createTextCursorByRange(xvc.getStart());
		xdt.insertString(xma, "a", true);
		xdh.executeDispatch(xdp, ".uno:InsertPara", "", 0, null);
 
		PropertyValue pv[] = new com.sun.star.beans.PropertyValue[4];
		cpv = pv;
		setProp(0, "FileName", "file:///home/dlevine/image.png");
		setProp(1, "FilterName", "<All formats>");
		setProp(2, "AsLink", false);
		setProp(3, "Style", "Graphics");
		xdh.executeDispatch(xdp, ".uno:InsertGraphic", "", 0, pv);
		getCurrent();
		xdh.executeDispatch(xdp, ".uno:Escape", "", 0, null);

		XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
		XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, objectS);
		xsp.setPropertyValue("ContentProtected", new Boolean(true));
            	xsp.setPropertyValue("AnchorType", TextContentAnchorType.AS_CHARACTER);
		xsp.setPropertyValue("AlternativeText", tex);
		jexname = (String) xsp.getPropertyValue("LinkDisplayName");
		jex.setTitle(jexname);
		xsp.setPropertyValue("VertOrient", new Integer(0));
		xsp.setPropertyValue("VertOrientPosition", new Integer(212));

	    	//XPropertySetInfo xps = xsp.getPropertySetInfo();
            	//Property xgp[] = xps.getProperties();
            	//for (int jj = 0; jj < xgp.length; jj++){
		//	System.out.println(xgp[jj].Name + " " + xsp.getPropertyValue(xgp[jj].Name));
	    	//}

		xt = (XTextContent) UnoRuntime.queryInterface(XTextContent.class, objectS);
		XTextRange xtr = xt.getAnchor();
		xma = xdt.createTextCursorByRange(xtr);
            	xma.goLeft((short) 2, true);
		xdt.insertString(xma, "", true);
		


	}
        catch( Exception exception ) {
            System.err.println("insertEq exception: " + exception );
        }

    }

    public void showChar(String str, String face, String style, int size, float stretch, float aftr, int x, double y, BoxMetrics m, int vshift){}

    public void setName(String name){
	jexname = name;
    }

    public String getName(){
	GregorianCalendar cal = new GregorianCalendar();
	return "Jex$$" + cal.getTimeInMillis();
    }

    public void grabEq(){
    
        try {
            getCurrent(); 


	    XShape xs = (XShape) UnoRuntime.queryInterface(XShape.class, objectS);
	    if(xs == null){
		Jex jex = Jex.newJex("{}");
		jex.setMathDisplay(new Jexoo(jex));
	    }
	    else{
	    	XPropertySet xsp = (XPropertySet)UnoRuntime.queryInterface(XPropertySet.class, xs);
            	String tex = (String) xsp.getPropertyValue("AlternativeText");
		String name = (String) xsp.getPropertyValue("LinkDisplayName");
	    	Jex jex = Jex.newJex(tex);
		Jexoo jexoo = new Jexoo(jex);
		jexoo.setName(name);
            	jex.setMathDisplay(jexoo);
		jex.setTitle(name);
	    }
        }
        catch( Exception exception ) {
            System.err.println("grabEq: " + exception );
        }
    }
}

class ooListen extends Thread {

	Jexoo jexoo;

	public void run () {
	
		while(true){

		try{

            		XComponentContext xcc = com.sun.star.comp.helper.Bootstrap.createInitialComponentContext(null);
            		XMultiComponentFactory xmsf = xcc.getServiceManager();
			Object aa = xmsf.createInstanceWithContext("com.sun.star.connection.Acceptor", xcc);
			XAcceptor xa = (XAcceptor) UnoRuntime.queryInterface(XAcceptor.class, aa);
			while(true) {
				jexoo = new Jexoo();
				xa.accept("socket,host=localhost,port=8101");
				jexoo.grabEq();
			}
		}
		catch(Exception e){
			System.out.println("ooListen connect exception " + e);
		}
		try{
			sleep(2000);
		}
		catch(Exception exception){
			System.err.println("ooListen exception: " + exception);
		}

		}
	}
}


